import {
    world,
    Player,
    system,
    BlockLocation,
    MinecraftEffectTypes
} from '@minecraft/server'
world.events.beforeChat.subscribe(v => {
    var {
        message, sender
    } = v
    var [cmd, subcmd] = message.split(/\s+/g)
    if (cmd == "!setbl" && subcmd) {
        v.cancel = true
        sender.addTag("setbl")
        setBlNum(sender, `bl:${subcmd}`)
    }
    if (cmd == "!clr") {
        v.cancel = true
        sender.removeTag("setbl")
    }
})
system.runSchedule(() => {
world.getAllPlayers().forEach(function(plr) {
    var {
        x,
        y,
        z
    } = plr.location
    var jumpBoost = ["-1 -54 42","-1 -54 51","-3 -54 54","1 -54 57","-3 -54 60","-1 -54 63","-1 -54 71","1 -54 74","-3 77","1 -54 80","-3 -54 83","0 -54 157","-3 -54 161","-1 -54 170","0 -54 176","1 -54 182","-1 -54 192","-3 -54 195","-3 -54 201","-9 -54 162","-9 -54 32"]
    var speedBoost = ["1 -54 94","1 -54 100","-3 -54 111","1 -54 114","-1 -54 117","-3 -54 120","1 -54 123","-2 -54 131","0 -54 134","-2 -54 137","0 -54 142","0 -54 158","-3 -54 162","-2 173","-2 -54 179","-3 -54 192","1 -54 198","-9 -54 161","-7 -54 103","-9 -54 97"]
    var belowBlockCords = new BlockLocation(Math.floor(x), Math.floor(y - 1), Math.floor(z))
    var belowBlock = plr.dimension.getBlock(belowBlockCords)
    if (belowBlock.typeId == "minecraft:diamond_block") {
        plr.runCommandAsync(`effect @s jump_boost 1 3`)
    } else if (belowBlock.typeId == "minecraft:emerald_block") {
        plr.runCommandAsync("effect @s speed 1 3")
    } else if (belowBlock.typeId == "minecraft:gold_block") {
        plr.runCommandAsync(`spawnpoint @s ${Math.floor(x)} ${Math.floor(y)} ${Math.floor(z)}`)
    } else if (jumpBoost.includes(`${Math.floor(x)} ${Math.floor(y - 1)} ${Math.floor(z)}`)) {
        plr.runCommandAsync(`effect @s jump_boost 1 3`)
    } else if (speedBoost.includes(`${Math.floor(x)} ${Math.floor(y - 1)} ${Math.floor(z)}`)) {
        plr.runCommandAsync(`effect @s speed 1 3`)
    } else if (belowBlock.typeId == "minecraft:grass") {
        plr.kill()
    }
})
},5)
world.events.blockPlace.subscribe(ev => {
    var block = ev.block
    var player = ev.player
    var data = getBlockData(block)
    var id = block.typeId
    var {
        x,
        y,
        z
    } = block.location
    player.getTags().forEach(tag => {
        if (tag.startsWith("bl:")) {
            var cod = tag.replace("bl:", "")
            var y2 = parseFloat(y) + parseFloat(cod)
            if (player.hasTag("setbl")) {
                player.runCommandAsync(`fill ${x} ${y} ${z} ${x} ${y2} ${z} ${id} ${data}`)
            }
        }
    })
})
function getBlockData(block) {
    var color = ['white', 'orange', 'magenta', 'light_blue', 'yellow', 'lime', 'pink', 'gray', 'silver', 'cyan', 'purple', 'blue', 'brown', 'green', 'red', 'black']
    var woods = ['oak', 'spruce', 'birch', 'jungle', 'acacia', 'dark_oak']
    var stones = ['stone', 'granite', 'granite_smooth', 'diorite', 'diorite_smooth', 'andesite', 'andesite_smooth']
    var walls = ['cobblestone', 'mossy_cobblestone', 'granite', 'diorite', 'andesite', 'sandstone', 'brick', 'stone_brick', 'mossy_stone_brick', 'nether_brick', 'end_brick', 'prismarine', 'red_sandstone', 'red_nether_brick']
    var sands = ['normal', 'red']
    var sponges = ['dry', 'wet']
    var stonebricks = ['default', 'mossy', 'cracked', 'chiseled', 'smooth']
    var sandstonetype = ['default', 'heiroglyphs', 'cut', 'smooth']
    var dplanttype = ['sunflower', 'syringa', 'grass', 'fern', 'rose', 'paeonia']
    var flowertype = ['poppy', 'orchid', 'allium', 'houstonia', 'tulip_red', 'tulip_orange', 'tulip_white', 'tulip_pink', 'oxeye', 'cornflower', 'lily_of_the_valley']
    var dirttype = ['normal', 'coarse']
    var anvil = ['undamaged', '', '', '', 'slightly_damaged', '', '', '', 'very_damaged', '', 'broken']
    var coralcolor = ['blue', 'pink', 'purple', 'red', 'yellow', 'blue dead', 'pink dead', 'red dead', 'yellow dead']
    var chiseltype = ['default', 'chiseled', 'lines', 'smooth']
    var newleaves = ['acacia', 'dark_oak']
    var newlog = ['acacia', 'dark_oak']
    var oldleafandlog = ['oak', 'spruce', 'birch', 'jungle']
    var stoneslab = ['', 'sandstone', '', 'cobblestone', 'brick', 'stone_brick', 'quartz', 'nether_brick', 'smooth_stone']
    var stoneslab2 = ['red_sandstone', 'purpur', 'prismarine_rough', 'prismarine_dark', 'prismarine_brick', 'mossy_cobblestone', 'smooth_sandstone', 'red_nether_brick']
    var stoneslab3 = ['end_stone_brick', 'smooth_red_sandstone', 'polished_andesite', 'andesite', 'diorite', 'polished_diorite', 'granite', 'polished_granite']
    var stoneslab4 = ['mossy_stone_brick', 'smooth_quartz', 'stone', 'cut_sandstone', 'cut_red_sandstone']
    var pristype = ['default', 'dark', 'bricks']
    var tallgtype = ['default', 'tall', 'fern', 'snow']
    if (block.permutation.getProperty("color")) {
        return color.indexOf(block.permutation.getProperty("color").value)
    } else if (block.permutation.getProperty("wood_type")) {
        return woods.indexOf(block.permutation.getProperty("wood_type").value)
    } else if (block.permutation.getProperty("stone_type")) {
        return stones.indexOf(block.permutation.getProperty("stone_type").value)
    } else if (block.permutation.getProperty("wall_block_type")) {
        return walls.indexOf(block.permutation.getProperty("wall_block_type").value)
    } else if (block.permutation.getProperty("sand_type")) {
        return sands.indexOf(block.permutation.getProperty("sand_type").value)
    } else if (block.permutation.getProperty("sponge_type")) {
        return sponges.indexOf(block.getProperty("sponge_type").value)
    } else if (block.permutation.getProperty("stone_brick_type")) {
        if (block.permutation.getProperty("stone_brick_type").value == "smooth") {
            return 0;

        } else {
            return stonebricks.indexOf(block.permutation.getProperty("stone_brick_type").value)
        }
    } else if (block.permutation.getProperty("sand_stone_type")) {
        return sandstonetype.indexOf(block.permutation.getProperty("sand_stone_type").value)
    } else if (block.permutation.getProperty("double_plant_type")) {
        return dplanttype.indexOf(block.permutation.getProperty("double_plant_type").value)
    } else if (block.permutation.getProperty("flower_type")) {
        return flowertype.indexOf(block.permutation.getProperty("flower_type").value)
    } else if (block.permutation.getProperty("dirt_type")) {
        return dirttype.indexOf(block.permutation.getProperty("dirt_type").value)
    } else if (block.permutation.getProperty("damage")) {
        return anvil.indexOf(block.permutation.getProperty("damage").value)
    } else if (block.permutation.getProperty("coral_color")) {
        return coralcolor.indexOf(block.permutation.getProperty("coral_color").value)
    } else if (block.permutation.getProperty("chisel_type")) {
        return chiseltype.indexOf(block.permutation.getProperty("chisel_type").value)
    } else if (block.permutation.getProperty("new_leaf_type")) {
        return newleaves.indexOf(block.permutation.getProperty("new_leaf_type").value)
    } else if (block.permutation.getProperty("new_log_type")) {
        return newlog.indexOf(block.permutation.getProperty("new_log_type").value)
    } else if (block.permutation.getProperty("old_leaf_type")) {
        return oldleafandlog.indexOf(block.permutation.getProperty("old_leaf_type").value)
    } else if (block.permutation.getProperty("old_log_type")) {
        return oldleafandlog.indexOf(block.permutation.getProperty("old_log_type").value)
    } else if (block.permutation.getProperty("stone_slab_type")) {
        return stoneslab.indexOf(block.permutation.getProperty("stone_slab_type").value)
    } else if (block.permutation.getProperty("stone_slab_type_2")) {
        return stoneslab2.indexOf(block.permutation.getProperty("stone_slab_type_2").value)
    } else if (block.permutation.getProperty("stone_slab_type_3")) {
        return stoneslab3.indexOf(block.permutation.getProperty("stone_slab_type_3").value)
    } else if (block.permutation.getProperty("stone_slab_type_4")) {
        return stoneslab4.indexOf(block.permutation.getProperty("stone_slab_type_4").value)
    } else if (block.permutation.getProperty("sapling_type")) {
        return woods.indexOf(block.permutation.getProperty("sapling_type").value)
    } else if (block.permutation.getProperty("prismarine_block_type")) {
        return pristype.indexOf(block.permutation.getProperty("prismarine_block_type").value)
    } else if (block.permutation.getProperty("tall_grass_type")) {
        return tallgtype.indexOf(block.permutation.getProperty("tall_grass_type").value)
    } else {
        return 0;
    }
}
function setBlNum(player, tg) {
    player.getTags().forEach(tag => {
        if (tag.startsWith("bl:")) {
            player.removeTag(tag)
        }
        player.addTag(tg)
    })
}